## org.codeberg.nykula.sapfir_9_src.tar.gz

=== android/app/essentia-prefix/essentia.js/src/python/requirements.txt ===
cogapp
# (remove this when official mtg-emscripten docker already has essentia python bindings installed)
essentia
