=== android/app/essentia-prefix/essentia/debian/control ===
Source: essentia
Maintainer: Dmitry Bogdanov <dmitry.bogdanov@upf.edu>
Section: sound
Priority: optional
Standards-Version: 3.9.6
Build-Depends: debhelper (>= 9), 
               libyaml-dev (>= 0.1.4), 
               libfftw3-dev (>= 3.3.2), 
               libavcodec-dev, 
               libavformat-dev, 
               libavutil-dev, 
               libswresample-dev,
               libsamplerate0-dev (>= 0.1.8), 
               libtag1-dev (>= 1.9.1), 
               python-dev, 
               python-numpy
Build-Depends-Indep: doxygen
XS-Python-Version: current

Package: libessentia-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: audio analysis tool -- development files
 Essentia is an audio analysis tool. It provides a reusable collection
 of algorithms and descriptors mainly used to extract features from
 audio files. It is written in C++, but also has Python bindings,
 meaning you can control it from within Python, and write scripts that
 use Essentia features (just as you would in Matlab).
 .
 This package contains the development files for libessentia.

Package: python-essentia
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
Description: audio analysis tool -- Python bindings
 Essentia is an audio analysis tool. It provides a reusable collection
 of algorithms and descriptors mainly used to extract features from
 audio files. It is written in C++, but also has Python bindings,
 meaning you can control it from within Python, and write scripts that
 use Essentia features (just as you would in Matlab).
 .
 This package contains all the required files to write applications using
 the Python language, plus some handy tools to work with audio files.

Package: essentia-extractors
Section: sound
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: audio analysis tool -- feature extractors
 Essentia is an audio analysis tool. It provides a reusable collection
 of algorithms and descriptors mainly used to extract features from
 audio files. It is written in C++, but also has Python bindings,
 meaning you can control it from within Python, and write scripts that
 use Essentia features (just as you would in Matlab).
 .
 This package contains command-line feature extractors based on 
 Essentia.

Package: essentia-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: audio analysis tool -- documentation
 Essentia is an audio analysis tool. It provides a reusable collection
 of algorithms and descriptors mainly used to extract features from
 audio files. It is written in C++, but also has Python bindings,
 meaning you can control it from within Python, and write scripts that
 use Essentia features (just as you would in Matlab).
 .
 This package contains all the documentation related to Essentia.
